"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CallSet(ProtocolElement):
    """
    A `CallSet` is a collection of variant calls for a particular sample.
    It belongs to a `VariantSet`. This is equivalent to one column in
    VCF.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.CallSet": reports_6_9_0.CallSet,
        }

    __slots__ = [
        "id",
        "created",
        "info",
        "name",
        "sampleId",
        "updated",
        "variantSetIds",
    ]

    def __init__(
        self,
        id,
        created=None,
        info=dict,
        name=None,
        sampleId=None,
        updated=None,
        variantSetIds=list,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.CallSet model.

        :param id:
            The call set ID.
        :type id: str
        :param created:
            The date this call set was created in milliseconds from the epoch.
        :type created: None | int
        :param info:
            A map of additional call set information.
        :type info: dict[str, list[str]]
        :param name:
            The call set name.
        :type name: None | str
        :param sampleId:
            The sample this call set's data was generated from.
        :type sampleId: None | str
        :param updated:
            The time at which this call set was last updated in milliseconds from
            the epoch.
        :type updated: None | int
        :param variantSetIds:
            The IDs of the variant sets this call set has calls in.
        :type variantSetIds: list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
